/*********************************************/
/*  IRS & TS & WS Device Driver Header Program    */
/*                                           */
/*                  developed by Eri.Taguchi */
/*                     ver 1.0  Dec. 16 2000 */
/*                  developed by Shinji Ushimaru */
/*                     ver 1.0  Mar. 16 2004 */
/*********************************************/

#define IRS_TS_WS_MAJOR 61
#define LEN 13
#define LINECOUNT 1

#define IRS_TS_WS_PORT_READ 0x0140
#define IRS_TS_WS_PORT_MASK 0x0142

#define IRS_TS_WS_IOC_MAGIC 'i'
#define IRS_READ         _IOR(IRS_TS_WS_IOC_MAGIC, 0,setcode)
#define TS_READ          _IOR(IRS_TS_WS_IOC_MAGIC, 1,setcode)
#define WS_READ          _IOR(IRS_TS_WS_IOC_MAGIC, 2,setcode)
#define PO_READ          _IOR(IRS_TS_WS_IOC_MAGIC, 3,setcode)
#define IRS_TS_WS_HARDRESET _IO(IRS_TS_WS_IOC_MAGIC,  4)
#define LCD_IOC_MAXNR 3
