#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "rotation.h"
#include "led.h"

int ioperm(unsigned long from, unsigned long num, int turn_on);

int post_approach0702(int target_post){

	int dis;
	int move_time;
	int r_value=0;
	int p_flag=0;

	ioperm(PORT,1,1);

	outb(FLASH1,PORT);
	usleep(1000);

	p_flag = correct_direction1(target_post);
	if(p_flag != -1){
		if(search_try_count==1 || warning_point==3){
			dis_approach=dis_approach-USS_MIN-post_diameter/2-MIRS_DIAMETER/2;
		}else{
			dis_approach=dis_approach-USS_MIN-MIRS_DIAMETER-post_diameter;
		}
		printf("%d[mm] Straight! \n",dis_approach);

		if(dis_approach<0){
			dis=500;
		}else{
			dis=dis_approach;
		}
		move_time=dis*8;

		lqr_straight(dis,move_time);

		circle_position(); 
		usleep(300000);
		r_value = 0;
	}else{
		printf("There is NO Post! \n");
		r_value = 9999;
	}

	outb(STOP,PORT);
	usleep(1000);
	
	return r_value;
}
