#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>
#include <asm/io.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "control.h"
#include "func_extern.h"
#include "rotation.h"
#include "uss.h"
#include "pwm_enc.h"


double angle_now=0.0;
/*
double ang_info[1000];
double uss_info[1000];
*/


int rot12(double,int);
int rot22(double,int);
int ioperm(unsigned long from, unsigned long num, int turn_on);


int main(void){
	int test_no=0,direct=0,cont=0;
	double ang=0.0;
	int ret;
	ret=initialize();
	
	do{
		printf("Rotation Test  :1\nRotation and USS Test  2:\n");
		scanf("%d",&test_no);
	
		switch (test_no){
			case 1:
				printf("Direction?\nRight  :0\nLeft  :1\n");
				scanf("%d",&direct);
				if(direct==0 || direct==1){
					printf("Angle?\n");
					scanf("%lf",&ang);
					rot12(ang,direct);

					break;
				}else{
					break;
				}
			case 2:
				printf("Direction?\nRight  :0\nLeft  :1\n");
				scanf("%d",&direct);
				if(direct==0 || direct==1){
					printf("Angle?\n");
					scanf("%lf",&ang);
					rot22(ang,direct);
					break;
				}else{
					break;
				}
		default:break;
	}
	printf("Continue? or Moi?\nContinue:1\nMoi:0\n");
	scanf("%d",&cont);
	}while(cont==1);
	return 0;
}


int rot12(double rot_angle,int rot_direction){
	
	double s = 0.375;
	double d = 0.0;						/*]pxp̕ϐ*/
	int rot_count = 0;					/*]Xebv*/
	int i;
	printf("In function <rot12>\n");
	if(rot_direction!=0 && rot_direction!=1 ){
		printf("rot_direction input error\n");
		goto owari;
	}
	if(rot_angle<-360.0 || rot_angle>360.0 ){
		printf("rot_direction input error\n");
		goto owari;
	}
	if(rot_direction==1)
	rot_angle=-rot_angle;
	
	if(angle_now>rot_angle){
		rot_direction=1;
		if(angle_now>0){
			if(rot_angle>=0){
				rot_angle=fabs(angle_now)-rot_angle;
			}else{
				rot_angle=angle_now+fabs(rot_angle);
			}
		}else{
			rot_angle=fabs(rot_angle)-fabs(angle_now);
		}
	}else if(angle_now<rot_angle){
		rot_direction=0;
		if(angle_now>=0){
			rot_angle=rot_angle-fabs(angle_now);
		}else{
			if(rot_angle>0){
				rot_angle=fabs(angle_now)+rot_angle;
			}else{
				rot_angle=fabs(angle_now)-rot_angle;
			}
		}
	}else{
		goto owari;
	}
	printf("Calculate\n");

	if(rot_angle<0){
		rot_angle=-rot_angle;
	}
	d = fmod(rot_angle,s);				/*]px0.375̗]߂*/
	rot_count = rot_angle / 0.375;		/*]px0.375ŉ]Xebv񐔂߂*/
	
	if( d >= 0.1875 ){					/*]肪0.1875ȏ̏ꍇArot_countɁ{1B*/
		rot_count++;
	}
	
	ioperm(rot_port,1,1);				/*rot_port1oCg̗̈mۂB*/
	
	
	switch (rot_direction){
		case 0:
			for(i=0;i<rot_count;i++){
				angle_now=angle_now+0.375;
				if(angle_now>360.0){
					angle_now=angle_now-0.375;
					goto owari;
				}
				outb(rot_right,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);

				printf("angle=%f\n",angle_now);
			}
			break;
		case 1:
			for(i=0;i<rot_count;i++){
				angle_now=angle_now-0.375;
				if(angle_now<-360.0){
					angle_now=angle_now+0.375;
					goto owari;
				}
				outb(rot_left,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);
				printf("angle=%f\n",angle_now);
			}
			break;
		default:break;
	}
owari:
	printf("END\n");
	return 0;
}

int rot22(double rot_angle,int rot_direction){
	

	double d = 0.0;						/*]pxp̕ϐ*/
	int rot_count = 0;					/*]Xebv*/
	/*int uss_data = 0;*/
	int i;
	double s = 0.375;
	int uss_code1 = 4;
	int uss_code2 = 5;
	int uss_obt1 = 0;
	int uss_obt2 = 0;
	int uss_avr = 0;				/*gf[^όvZpϐ*/
	
	kosuu=0;						/*gœp̕ϐ̏*/
	




	
	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);		/*Xbh̐*/


	if(rot_direction==1){
		rot_angle=-rot_angle;
	}
	
	if(angle_now>rot_angle){
		rot_direction=1;
		if(angle_now>0){
			if(rot_angle>=0){
				rot_angle=fabs(angle_now)-rot_angle;
			}else{
				rot_angle=angle_now+fabs(rot_angle);
			}
		}else{
			rot_angle=fabs(rot_angle)-fabs(angle_now);
		}
	}else if(angle_now<rot_angle){
		rot_direction=0;
		if(angle_now>=0){
			rot_angle=rot_angle-fabs(angle_now);
		}else{
			if(rot_angle>0){
				rot_angle=fabs(angle_now)+rot_angle;
			}else{
				rot_angle=fabs(angle_now)-rot_angle;
			}
		}
	}else{
		goto owari2;
	}
	printf("Calculate\n");


	if(rot_angle<0){
		rot_angle=-rot_angle;
	}

	d = fmod(rot_angle,s);				/*]px0.375̗]߂*/
	rot_count = rot_angle / 0.375;		/*]px0.375ŉ]Xebv񐔂߂*/
	
	if( d >= 0.1875 ){					/*]肪0.1875ȏ̏ꍇArot_countɁ{1B*/
		rot_count++;
	}
	
	ioperm(rot_port,1,1);				/*rot_port1oCg̗̈mۂB*/
	
	
	switch (rot_direction){
		case 0:
			for(i=0;i<rot_count;i++){
				if(angle_now<0){
					ang_info[i] =-angle_now;
				}else if(angle_now>0){
					ang_info[i] = 360-angle_now;
				}else{
					ang_info[i] = 0;
				}
				printf("angle=%f\n",angle_now);				
			    
				if((i%10)==0 || i==0){
					uss_obt1 = uss_get(uss_code1);
					uss_obt2 = uss_get(uss_code2);
					if( uss_obt1 >= USS_MAX && uss_obt1 <= USS_MIN ){
					uss_obt1=9999;
				    }

				    if( uss_obt2 >= USS_MAX && uss_obt2 <= USS_MIN ){
						uss_obt2=9999;
			    }

				    uss_avr=(uss_obt1+uss_obt2)/2;
				    kosuu++;
			    



				}
			    
				angle_now=angle_now+0.375;
				if(angle_now>360.0){
					angle_now=angle_now-0.375;
					goto owari2;
				}
				outb(rot_right,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);

				
			}
			break;
		case 1:
			for(i=0;i<rot_count;i++){
				if(angle_now<0){
					ang_info[i] =-angle_now;
				}else if(angle_now>0){
					ang_info[i] = 360-angle_now;
				}else{
					ang_info[i] = 0;
				}
				
				printf("angle=%f\n",angle_now);			    
				
				if((i%10)==0 || i==0){
					uss_obt1 = uss_get(uss_code1);
					uss_obt2 = uss_get(uss_code2);
					if( uss_obt1 >= USS_MAX && uss_obt1 <= USS_MIN ){
					uss_obt1=9999;
				    }

				    if( uss_obt2 >= USS_MAX && uss_obt2 <= USS_MIN ){
						uss_obt2=9999;
			    }

				    uss_avr=(uss_obt1+uss_obt2)/2;
				    kosuu++;
			    



				}				
				
				angle_now=angle_now-0.375;
				if(angle_now<-360.0){
					angle_now=angle_now+0.375;
					goto owari2;
				}
				outb(rot_left,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);

			}
			break;
		default:break;
	}
owari2: 
	printf("Post Number : %d \n",kosuu);




	
	pthread_cancel(uss_task2);
	
	return 0;
}
