#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "rotation.h"
#include "led.h"

#define PLS_HOSEI 35	//hosei +[mm]
#define MNS_HOSEI 20	//hosei -[mm]
#define CLR_POINT 2	//clear point of total

int select_post2(void){
	int i,j1,j2,j3,j4=0,cnt=0,bef_cnt,aft_cnt,index,dis,dis_d,ang_d,selcnt=0,j=0,count_sel=0,result;

	int ang_sure[100];
	int dis_sure[100];

	int dis_f[1000];
	int ang_f[1000];

	int dis_f_i[1000];
	int ang_f_i[1000];

	int dis_f_j[1000];
	int ang_f_j[1000];

	int ang_s[1000];
	int dis_s[1000];

	int flg[1000];

	for(i=0;i<1000;i++){
		dis_f[i]=9999;
		ang_f[i]=9999;

		dis_f_i[i]=9999;
		ang_f_i[i]=9999;
		dis_f_j[i]=9999;
		ang_f_j[i]=9999;

		ang_s[i]=9999;
		dis_s[i]=9999;
	}

	cnt=kosuu;

	for(i=0;i<kosuu;i++){
		ang_f[i]=(int)(ang_info[i]+0.5);
		dis_f[i]=(int)(dis_info[i]+127+100);
	}
	for(i=0;i<kosuu;i++){
		dis_f_i[i]=(int)(sqrt(pow(dis_f[i],2)+pow(360,2)));
		ang_f_i[i]=ang_f[i]+(int)(asin(dis_f[i]/dis_f_i[i])*180/3.1415927);
		if(ang_f_i[i]>=300){
			selcnt++;
		}
	}

	for(i=kosuu-selcnt;i<kosuu;i++){
		dis_f_j[j]=dis_f_i[i];
		j++;
	}
	for(i=0;i<kosuu-selcnt;i++){
		dis_f_j[i+j]=dis_f_i[i];
	}

	for(i=0;i<kosuu;i++){
		dis_s[i]=dis_f_j[i];
		ang_s[i]=ang_f_i[i];
	}

	for(i=0;i<1000;i++){
		flg[i]=0;
	}

	for(i=0;i<1000;i++){
		if(dis_s[i]>USS_MAX || dis_s[i]<USS_MIN){
			flg[i]=1;
		}
		if(search_try_count>1){
			if(ang_s[i]>RM_ANG1 || ang_s[i]<RM_ANG2){
				flg[i]=1;
			}
		}
	}

JUDGE:

	index=-1;
	for(i=0;i<cnt;i++){
		if(flg[i]==0){
			index=i;
		}
	}
	if(index==-1){
		goto END;
	}
	
	
	for(i=1;i<cnt;i++){
		if(dis_s[index]>dis_s[i] && flg[i]==0){
			index=i;
		}
	}

	aft_cnt=0;
	for(i=index;i<index+6;i++){
		if(i>=cnt){j1=i-cnt;}else{j1=i;}
		if((i+1)>=cnt){j2=i+1-cnt;}else{j2=i+1;}
		if((i+2)>=cnt){j3=i+2-cnt;}else{j3=i+2;}
		dis=dis_s[j2]+(dis_s[j2]-dis_s[j1]);
		if((dis+PLS_HOSEI>dis_s[j3] && dis-MNS_HOSEI<dis_s[j3]) && flg[j3]==0){
			if(aft_cnt==0){aft_cnt+=2;}else{aft_cnt++;}
		}else{
			break;
		}
	}

	bef_cnt=0;
	for(i=index;i>index-6;i--){
		if(i<0){j1=i+cnt;}else{j1=i;}
		if((i-1)<0){j2=i-1+cnt;}else{j2=i-1;}
		if((i-2)<0){j3=i-2+cnt;}else{j3=i-2;}
		dis=dis_s[j2]+(dis_s[j2]-dis_s[j1]);
		if((dis+PLS_HOSEI>dis_s[j3] && dis-MNS_HOSEI<dis_s[j3]) && flg[j3]==0){
			if(bef_cnt==0){bef_cnt+=2;}else{bef_cnt++;}
		}else{
			break;
		}
	}

	if((aft_cnt+bef_cnt)>=CLR_POINT){

		flg[index]=2;
		for(i=index+1;i<=index+aft_cnt;i++){
			if(i>=cnt){j1=i-cnt;}else{j1=i;}
			flg[j1]=1;
		}
		for(i=index-1;i>=index-bef_cnt;i--){
			if(i<0){j1=i+cnt;}else{j1=i;}
			flg[j1]=1;
		}
	}else{
		flg[index]=1;
	}
	goto JUDGE;

END:
	j1=0;
	for(i=0;i<cnt;i++){
		if(flg[i]==2){
			ang_d=ang_s[i];
			while(ang_d>=360){ang_d-=360;}
			dis_d=dis_s[i];
			
			ang_sure[j1]=ang_d;
			dis_sure[j1]=dis_d;
			j1++;
			
		}
	}
	
	for(i=0;i<j1;i++){
		result=route3((double)ang_sure[i],(double)dis_sure[i]);
		if(result==0){
			ang_select[count_sel]=ang_sure[i];
			dis_select[count_sel]=dis_sure[i];
			count_sel++;
			j4++;
		}
	}

	search_post=j4;

	return 0;
}
