#include <stdio.h>
#include <unistd.h>
#include "../control/func_extern.h"
#include "pwm_enc.h"

int main()
{
        int left_cm, right_cm, mode;
        int br=0;
        int ang_time;
	int ct=0;
        float alw,arw;
        float V,Omega;

	int l_duty;   // left duty value
	int r_duty;  // right duty value
	int cmax=100;     // maxmum count
	FILE *fp;

	printf("l_duty=");
	scanf("%d",&l_duty);printf("\n");
	printf("r_duty=");
	scanf("%d",&r_duty);printf("\n");
	printf("case=");
	scanf("%d",&mode);printf("\n");

switch(mode){
        case 1:
		if((fp=fopen("/home/atlmirs/mirs_std/pwm_enc/data/keisoku1.data","w"))==NULL){
                	printf("File not open\n");
                	exit(1);
        	}

        	pwm_both_data(l_duty,r_duty);

        	usleep(5000);
        	pwm_enco_start(10);

        	printf("No	omega_l	omega_r \n",ct,alw,arw,br);
        	fprintf(fp,"No	omega_l	omega_r \n",ct,alw,arw,br);
        	while(1){
			ct++;
                	encoder_data4(&alw,&arw,&V,&Omega,&br);
                	printf("%3d	%6.3f	%6.3f \n",ct,alw,arw);
                	fprintf(fp,"%3d	%6.3f	%6.3f \n",ct,alw,arw);
                	//fprintf(fp,"%3d %5.2f %5.2f %5.2f %5.2f \n",ct,alw,arw,V/1000,Omega);
                	if(ct>cmax) break;
        	}
		break;
	case 2:
		if((fp=fopen("/home/atlmirs/mirs_std/pwm_enc/data/keisoku2.data","w"))==NULL){
                	printf("File not open\n");
                	exit(1);
        	}

        	pwm_both_data(l_duty,r_duty);

        	usleep(5000);
        	pwm_enco_start(10);

        	printf("No	Velocity \n",ct,V,br);
        	fprintf(fp,"No	Velocity \n",ct,V,br);
        	while(1){
			ct++;
                	encoder_data5(&alw,&arw,&V,&Omega,&br);
                	printf("%3d	%6.3f \n",ct,V/1000);
                	fprintf(fp,"%3d	%6.3f \n",ct,V/1000);
                	//fprintf(fp,"%3d %5.2f %5.2f %5.2f %5.2f \n",ct,alw,arw,V/1000,Omega);
                	if(ct>cmax) break;
		}
		break;
	case 3:
		if((fp=fopen("/home/atlmirs/mirs_std/pwm_enc/data/keisoku3.data","w"))==NULL){
                	printf("File not open\n");
                	exit(1);
        	}

        	pwm_both_data(l_duty,r_duty);

        	usleep(5000);
        	pwm_enco_start(10);

        	printf("No	Omega \n",ct,Omega,br);
        	fprintf(fp,"No	Omega \n",ct,Omega,br);
        	while(1){
			ct++;
                	encoder_data5(&alw,&arw,&V,&Omega,&br);
                	printf("%3d	%6.3f \n",ct,Omega);
                	fprintf(fp,"%3d	%6.3f \n",ct,Omega);
                	//fprintf(fp,"%3d %5.2f %5.2f %5.2f %5.2f \n",ct,alw,arw,V/1000,Omega);
                	if(ct>cmax) break;
		}
		break;
	default :
		if((fp=fopen("/home/atlmirs/mirs_std/pwm_enc/data/error.data","w"))==NULL){
			printf("File not open\n");
			exit(1);
		}
		break;
	}
        fclose(fp);
        pwm_both_data(0, 0);
        usleep(1000);
        pwm_enco_stop();
        printf("Program stopped\n");
        return 0;
}
