#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>
#include <asm/io.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
/*#include "func_extern.h"*/
#include "rotation.h"
#include "uss.h"
#include "control.h"

double angle_now=0.0;
double ang_info[1000];
double uss_info[1000];


int kosuu;	/*Oϐɓo^ȂI*/
int rot1(double,int);
int rot2(double,int);
int test(void);
int ioperm(unsigned long from, unsigned long num, int turn_on);
int uss_get(int);
void *uss_read2(void *);

int main(void){
	int test_no=0,direct=0;
	double ang=0.0;
	
	printf("TEST!\nUSS Test  :1\nRotation Test  :2\nRotation and USS Test  3:\n");
	scanf("%d",&test_no);
	
	switch (test_no){
		case 1:
			test();
			break;
		case 2:
			printf("Direction?\nRight  :0\nLeft  :1\n");
			scanf("%d",&direct);
			if(direct==0 || direct==1){
			printf("Angle?\n");
			scanf("%lf",&ang);
			if(ang)
			rot1(ang,direct);
			break;
			}else{
				break;
			}
		case 3:
			printf("Direction?\nRight  :0\nLeft  :1\n");
			scanf("%d",&direct);
			if(direct==0 || direct==1){
			printf("Angle?\n");
			scanf("%lf",&ang);
			if(ang)
			rot2(ang,direct);
			break;
			}else{
				break;
			}
		default:break;
	}
	return 0;
}


void *uss_transmit(int *uss_no){
        struct timeval tv;
        struct uss_msg_struct uss_msg;

	int cmd;
	int n;
        fd_set rfds;
        int retval;
        int fd0, ctl;
	int bufsize=10;
	int buf[bufsize];

        uss_msg.command=1; /* Shot */
        uss_msg.number=*uss_no;
        cmd = *uss_no;

	//printf("uss_no =%d\n",cmd);

        if ((fd0 = open("/dev/rtf2", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf2\n");
                exit(1);
        }

        if ((ctl = open("/dev/rtf1", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf1\n");
                exit(1);
        }

        while(1) {
                        if (write(ctl, &uss_msg, sizeof(uss_msg)) < 0){
                                fprintf(stderr, "uss_transmit:now sending commands to uss%d.\n", cmd);
                                continue;
                        }
                        FD_ZERO(&rfds);
                        FD_SET(fd0, &rfds);
                        tv.tv_sec = 0;
                        tv.tv_usec = 100000;

                        retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
                        if (retval > 0) {
                                if (FD_ISSET(fd0, &rfds)) {
                                        n = read(fd0, buf, bufsize - 1);
                                        buf[n] = 0;
                                        uss_data = buf[0];
                                        break;
                                }
                        }
                        else {
                                uss_data = 999;
                                break;
                        }

        }
	close(fd0);
	close(ctl);
        pthread_exit(0);
}

int test(void)
{

        pthread_t uss_task;
        pthread_attr_t attr_uss;
	struct sched_param sched_param;


	int uss_no;
	int comand;
	int ret,j;

        pthread_attr_init (&attr_uss);
        sched_param.sched_priority = 21;
	pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
        pthread_attr_setschedparam(&attr_uss, &sched_param);

	comand = 1;
	//uss_no=1;

	//for(i=0;i<2;i++){
	while(1){
		//for(j=3;j<4;j++){
		for(j=1;j<7;j++){
			uss_no=j;	
        		ret=pthread_create( &uss_task, &attr_uss, (void*)uss_transmit, &uss_no);
			ret=pthread_join(uss_task,NULL);
			printf("uss[%d] = %d\n",uss_no,uss_data);
			usleep(1000000);
		}
	}

	return 0;
}

int rot1(double rot_angle,int direction){
	
	double s = 0.375;
	double d = 0.0;						/*]pxp̕ϐ*/
	int rot_count = 0;					/*]Xebv*/
	int i;
	
	if(direction!=0 && direction!=1 ){
		printf("direction input error\n");
		goto owari;
	}
	if(rot_angle<-360.0 || rot_angle>360.0 ){
		printf("direction input error\n");
		goto owari;
	}
	if(direction==1)
	rot_angle=-rot_angle;
	
	if(angle_now>rot_angle){
		direction=1;
		if(angle_now>0){
			if(rot_angle>=0){
				rot_angle=fabs(angle_now)-rot_angle;
			}else{
				rot_angle=angle_now+rot_angle;
			}
		}else{
			rot_angle=rot_angle-fabs(angle_now);
		}
	}else if(angle_now<rot_angle){
		direction=0;
		if(angle_now>=0){
			rot_angle=rot_angle-fabs(angle_now);
		}else{
			if(rot_angle>0){
				rot_angle=fabs(angle_now)+rot_angle;
			}else{
				rot_angle=fabs(angle_now)-rot_angle;
			}
		}
	}else{
		goto owari;
	}
	printf("Calculate\n");

	if(rot_angle<0){
		rot_angle=-rot_angle;
	}
	d = fmod(rot_angle,s);				/*]px0.375̗]߂*/
	rot_count = rot_angle / 0.375;		/*]px0.375ŉ]Xebv񐔂߂*/
	
	if( d >= 0.1875 ){					/*]肪0.1875ȏ̏ꍇArot_countɁ{1B*/
		rot_count++;
	}
	
	ioperm(rot_port,1,1);				/*rot_port1oCg̗̈mۂB*/
	
	
	switch (direction){
		case 0:
			for(i=0;i<rot_count;i++){
				angle_now=angle_now+0.375;
				if(angle_now>360.0){
					angle_now=angle_now-0.375;
					goto owari;
				}
				outb(rot_right,rot_port);
				usleep(100000);
				outb(rot_stop,rot_port);
				usleep(100000);

				printf("angle=%f\n",angle_now);
			}
			break;
		case 1:
			for(i=0;i<rot_count;i++){
				angle_now=angle_now-0.375;
				if(angle_now<-360.0){
					angle_now=angle_now+0.375;
					goto owari;
				}
				outb(rot_left,rot_port);
				usleep(100000);
				outb(rot_stop,rot_port);
				usleep(100000);
				printf("angle=%f\n",angle_now);
			}
			break;
		default:break;
	}
owari:
	printf("END\n");
	return 0;
}

int rot2(double rot_angle,int direction){
	
	FILE *fp,*fq;
	double d = 0.0;						/*]pxp̕ϐ*/
	int rot_count = 0;					/*]Xebv*/
	/*int uss_data = 0;*/
	int i;
	double s = 0.375;
	int uss_code = 3;
	int uss_obt = 0;
	
	kosuu=0;						/*gœp̕ϐ̏*/
	
	fp = fopen("uss_dis_sample.txt", "w");
	fq = fopen("uss_ang_sample.txt", "w");
	
	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);		/*Xbh̐*/


	if(direction==1){
		rot_angle=-rot_angle;
	}
	
	if(angle_now>rot_angle){
		direction=1;
		if(angle_now>0){
			if(rot_angle>=0){
				rot_angle=fabs(angle_now)-rot_angle;
			}else{
				rot_angle=angle_now+rot_angle;
			}
		}else{
			rot_angle=rot_angle-fabs(angle_now);
		}
	}else if(angle_now<rot_angle){
		direction=0;
		if(angle_now>=0){
			rot_angle=rot_angle-fabs(angle_now);
		}else{
			if(rot_angle>0){
				rot_angle=fabs(angle_now)+rot_angle;
			}else{
				rot_angle=fabs(angle_now)-rot_angle;
			}
		}
	}else{
		goto owari2;
	}
	printf("Calculate\n");


	if(rot_angle<0){
		rot_angle=-rot_angle;
	}

	d = fmod(rot_angle,s);				/*]px0.375̗]߂*/
	rot_count = rot_angle / 0.375;		/*]px0.375ŉ]Xebv񐔂߂*/
	
	if( d >= 0.1875 ){					/*]肪0.1875ȏ̏ꍇArot_countɁ{1B*/
		rot_count++;
	}
	
	ioperm(rot_port,1,1);				/*rot_port1oCg̗̈mۂB*/
	
	
	switch (direction){
		case 0:
			for(i=0;i<rot_count;i++){
				if(angle_now<0){
					ang_info[i] = 360.0+angle_now;
				}else{
					ang_info[i] = angle_now;
				}
				uss_obt = uss_get(uss_code);
				if( uss_obt < USS_MAX && uss_obt > USS_MIN ){
					uss_info[i] = uss_obt;
					kosuu++;
			    }else {                                 /* gZT̒l͈̔͊Ołꍇ0ۑ */
					uss_info[i] = 9999;
					kosuu++;
				}
				angle_now=angle_now+0.375;
				if(angle_now>360.0){
					angle_now=angle_now-0.375;
					goto owari2;
				}
				outb(rot_right,rot_port);
				usleep(100000);
				outb(rot_stop,rot_port);
				usleep(100000);
				printf("angle=%f\n",angle_now);
				fprintf(fp,"%d\n",uss_obt);
				fprintf(fq,"%f\n",ang_info[i]);
			}
			break;
		case 1:
			for(i=0;i<rot_count;i++){
				if(angle_now<0){
					ang_info[i] = 360.0+angle_now;
				}else{
					ang_info[i] = angle_now;
				}
				uss_obt = uss_get(uss_code);
				if( uss_obt < USS_MAX && uss_obt > USS_MIN ){
					uss_info[i] = uss_obt;
					kosuu++;
			    }else {                                 /* gZT̒l͈̔͊Ołꍇ0ۑ */
					uss_info[i] = 9999;
					kosuu++;
				}
				angle_now=angle_now-0.375;
				if(angle_now<-360.0){
					angle_now=angle_now+0.375;
					goto owari2;
				}
				outb(rot_left,rot_port);
				usleep(100000);
				outb(rot_stop,rot_port);
				usleep(100000);
				printf("angle=%f\n",angle_now);
				fprintf(fp,"%d\n",uss_obt);
				fprintf(fq,"%f\n",ang_info[i]);
			}
			break;
		default:break;
	}
owari2: 

	fclose(fp);
	fclose(fq);
	
	pthread_cancel(uss_task2);
	
	return 0;
}
